% Copyright (C) 2012 - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/

\documentclass[12pt]{article}

\include{macros}

\begin{document}
\author{Micha\"el Baudin}
\date{July 2012}
\title{Writing Scilab Extensions}
\maketitle
\begin{abstract}
In this document, we present methods to use and create Scilab 
extensions.

In the first part, we focus on the use of external modules. 
We describe their general organization and how to install a module from ATOMS. 
Then we describe how to build a module from the sources.
In the second part, we present the management of a toolbox, and the 
purpose of each directory. 
We emphasize the use of simple methods to automatically create the 
help pages and to manage the unit tests.
Then we present the creation of interfaces, which allows to 
connect Scilab to a compiled C, C++ or Fortran library. 
We consider the example of a simple function in the C language 
and explore several ways to make this function available to Scilab. 
We consider a simple method based on
exchanging data by file. 
We then present a method based on the \scifun{call} function. 
Finally, we present the classical, but more advanced, method to create a gateway
and how to use the Scilab API. 
The two last sections focus on designing issues, such as managing the 
optional input or output arguments or designing examples. 
\end{abstract}

\tableofcontents

\input{copyright}

\include{sciextensions/sciextensions}

\clearpage

%% Bibliography

\addcontentsline{toc}{section}{Bibliography}
\bibliographystyle{plain}
\bibliography{sciextensions}

\addcontentsline{toc}{section}{Index}
\printindex

\end{document}

